Module javafx.base
Package javafx.beans.binding

## Class FloatExpression

- java.lang.Object
- - javafx.beans.binding.NumberExpressionBase
  - - javafx.beans.binding.FloatExpression

- All Implemented Interfaces:
    `NumberExpression`, `Observable`, `ObservableFloatValue`, `ObservableNumberValue`, `ObservableValue<Number>`
  Direct Known Subclasses:
    `FloatBinding`, `ReadOnlyFloatProperty`

      public abstract class FloatExpression
      extends NumberExpressionBase
      implements ObservableFloatValue

  `FloatExpression` is an `ObservableFloatValue` plus additional convenience methods to generate bindings in a fluent style.

  A concrete sub-class of `FloatExpression` has to implement the method `ObservableFloatValue.get()`, which provides the actual value of this expression.

  Since:
    JavaFX 2.0

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FloatExpression()` |

  - ### Method Summary

    Modifier and Type | Method | Description
    --- | --- | ---
    `DoubleBinding` | `add​(double other)` | Creates a new `NumberBinding` that calculates the sum of this `NumberExpression` and a constant value.
    `FloatBinding` | `add​(float other)` | Creates a new `NumberBinding` that calculates the sum of this `NumberExpression` and a constant value.
    `FloatBinding` | `add​(int other)` | Creates a new `NumberBinding` that calculates the sum of this `NumberExpression` and a constant value.
    `FloatBinding` | `add​(long other)` | Creates a new `NumberBinding` that calculates the sum of this `NumberExpression` and a constant value.
    `ObjectExpression<Float>` | `asObject()` | Creates an `ObjectExpression` that holds the value of this `FloatExpression`.
    `DoubleBinding` | `divide​(double other)` | Creates a new `NumberBinding` that calculates the division of this `NumberExpression` and a constant value.
    `FloatBinding` | `divide​(float other)` | Creates a new `NumberBinding` that calculates the division of this `NumberExpression` and a constant value.
    `FloatBinding` | `divide​(int other)` | Creates a new `NumberBinding` that calculates the division of this `NumberExpression` and a constant value.
    `FloatBinding` | `divide​(long other)` | Creates a new `NumberBinding` that calculates the division of this `NumberExpression` and a constant value.
    `double` | `doubleValue()` | Returns the value of this `ObservableNumberValue` as a `double`.
    `static FloatExpression` | `floatExpression​(ObservableFloatValue value)` | Returns a `FloatExpression` that wraps a `ObservableFloatValue`.
    `static <T extends Number> FloatExpression` | `floatExpression​(ObservableValue<T> value)` | Returns a `FloatExpression` that wraps an `ObservableValue`.
    `float` | `floatValue()` | Returns the value of this `ObservableNumberValue` as a `float`.
    `Float` | `getValue()` | Returns the current value of this `ObservableValue`
    `int` | `intValue()` | Returns the value of this `ObservableNumberValue` as an `int` .
    `long` | `longValue()` | Returns the value of this `ObservableNumberValue` as a `long` .
    `DoubleBinding` | `multiply​(double other)` | Creates a new `NumberBinding` that calculates the product of this `NumberExpression` and a constant value.
    `FloatBinding` | `multiply​(float other)` | Creates a new `NumberBinding` that calculates the product of this `NumberExpression` and a constant value.
    `FloatBinding` | `multiply​(int other)` | Creates a new `NumberBinding` that calculates the product of this `NumberExpression` and a constant value.
    `FloatBinding` | `multiply​(long other)` | Creates a new `NumberBinding` that calculates the product of this `NumberExpression` and a constant value.
    `FloatBinding` | `negate()` | Creates a new `NumberBinding` that calculates the negation of `NumberExpression`.
    `DoubleBinding` | `subtract​(double other)` | Creates a new `NumberBinding` that calculates the difference of this `NumberExpression` and a constant value.
    `FloatBinding` | `subtract​(float other)` | Creates a new `NumberBinding` that calculates the difference of this `NumberExpression` and a constant value.
    `FloatBinding` | `subtract​(int other)` | Creates a new `NumberBinding` that calculates the difference of this `NumberExpression` and a constant value.
    `FloatBinding` | `subtract​(long other)` | Creates a new `NumberBinding` that calculates the difference of this `NumberExpression` and a constant value.

    - ### Methods inherited from class javafx.beans.binding.NumberExpressionBase

      `add, asString, asString, asString, divide, greaterThan, greaterThan, greaterThan, greaterThan, greaterThan, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, lessThan, lessThan, lessThan, lessThan, lessThan, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, multiply, numberExpression, subtract`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javafx.beans.Observable

      `addListener, removeListener`

    - ### Methods inherited from interface javafx.beans.value.ObservableFloatValue

      `get`

    - ### Methods inherited from interface javafx.beans.value.ObservableValue

      `addListener, removeListener`

- - ### Constructor Detail

    - #### FloatExpression

          public FloatExpression()

  - ### Method Detail

    - #### intValue

          public int intValue()

      Description copied from interface: `ObservableNumberValue`
      Returns the value of this `ObservableNumberValue` as an `int` . If the value is not an `int`, a standard cast is performed.
      Specified by:
        `intValue` in interface `ObservableNumberValue`
      Returns:
        The value of this `ObservableNumberValue` as an `int`

    - #### longValue

          public long longValue()

      Description copied from interface: `ObservableNumberValue`
      Returns the value of this `ObservableNumberValue` as a `long` . If the value is not a `long`, a standard cast is performed.
      Specified by:
        `longValue` in interface `ObservableNumberValue`
      Returns:
        The value of this `ObservableNumberValue` as a `long`

    - #### floatValue

          public float floatValue()

      Description copied from interface: `ObservableNumberValue`
      Returns the value of this `ObservableNumberValue` as a `float`. If the value is not a `float`, a standard cast is performed.
      Specified by:
        `floatValue` in interface `ObservableNumberValue`
      Returns:
        The value of this `ObservableNumberValue` as a `float`

    - #### doubleValue

          public double doubleValue()

      Description copied from interface: `ObservableNumberValue`
      Returns the value of this `ObservableNumberValue` as a `double`. If the value is not a `double`, a standard cast is performed.
      Specified by:
        `doubleValue` in interface `ObservableNumberValue`
      Returns:
        The value of this `ObservableNumberValue` as a `double`

    - #### getValue

          public Float getValue()

      Description copied from interface: `ObservableValue`
      Returns the current value of this `ObservableValue`
      Specified by:
        `getValue` in interface `ObservableValue<Number>`
      Returns:
        The current value

    - #### floatExpression

          public static FloatExpression floatExpression​(ObservableFloatValue value)

      Returns a `FloatExpression` that wraps a `ObservableFloatValue`. If the `ObservableFloatValue` is already a `FloatExpression`, it will be returned. Otherwise a new `FloatBinding` is created that is bound to the `ObservableFloatValue`.
      Parameters:
        `value` - The source `ObservableFloatValue`
      Returns:
        A `FloatExpression` that wraps the `ObservableFloatValue` if necessary
      Throws:
        `NullPointerException` - if `value` is `null`

    - #### floatExpression

          public static <T extends Number> FloatExpression floatExpression​(ObservableValue<T> value)

      Returns a `FloatExpression` that wraps an `ObservableValue`. If the `ObservableValue` is already a `FloatExpression`, it will be returned. Otherwise a new `FloatBinding` is created that is bound to the `ObservableValue`.

      Note: this method can be used to convert an `ObjectExpression` or `ObjectProperty` of specific number type to FloatExpression, which is essentially an `ObservableValue<Number>`. See sample below.

      >        FloatProperty floatProperty = new SimpleFloatProperty(1.0f);
      >        ObjectProperty<Float> objectProperty = new SimpleObjectProperty<>(2.0f);
      >        BooleanBinding binding = floatProperty.greaterThan(FloatExpression.floatExpression(objectProperty));

      Note: null values will be interpreted as 0f
      Type Parameters:
        `T` - The type of Number to be wrapped
      Parameters:
        `value` - The source `ObservableValue`
      Returns:
        A `FloatExpression` that wraps the `ObservableValue` if necessary
      Throws:
        `NullPointerException` - if `value` is `null`
      Since:
        JavaFX 8.0

    - #### negate

          public FloatBinding negate()

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the negation of `NumberExpression`.
      Specified by:
        `negate` in interface `NumberExpression`
      Returns:
        the new `NumberBinding`

    - #### add

          public DoubleBinding add​(double other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the sum of this `NumberExpression` and a constant value.
      Specified by:
        `add` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### add

          public FloatBinding add​(float other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the sum of this `NumberExpression` and a constant value.
      Specified by:
        `add` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### add

          public FloatBinding add​(long other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the sum of this `NumberExpression` and a constant value.
      Specified by:
        `add` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### add

          public FloatBinding add​(int other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the sum of this `NumberExpression` and a constant value.
      Specified by:
        `add` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### subtract

          public DoubleBinding subtract​(double other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the difference of this `NumberExpression` and a constant value.
      Specified by:
        `subtract` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### subtract

          public FloatBinding subtract​(float other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the difference of this `NumberExpression` and a constant value.
      Specified by:
        `subtract` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### subtract

          public FloatBinding subtract​(long other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the difference of this `NumberExpression` and a constant value.
      Specified by:
        `subtract` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### subtract

          public FloatBinding subtract​(int other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the difference of this `NumberExpression` and a constant value.
      Specified by:
        `subtract` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### multiply

          public DoubleBinding multiply​(double other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the product of this `NumberExpression` and a constant value.
      Specified by:
        `multiply` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### multiply

          public FloatBinding multiply​(float other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the product of this `NumberExpression` and a constant value.
      Specified by:
        `multiply` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### multiply

          public FloatBinding multiply​(long other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the product of this `NumberExpression` and a constant value.
      Specified by:
        `multiply` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### multiply

          public FloatBinding multiply​(int other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the product of this `NumberExpression` and a constant value.
      Specified by:
        `multiply` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### divide

          public DoubleBinding divide​(double other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the division of this `NumberExpression` and a constant value.
      Specified by:
        `divide` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### divide

          public FloatBinding divide​(float other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the division of this `NumberExpression` and a constant value.
      Specified by:
        `divide` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### divide

          public FloatBinding divide​(long other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the division of this `NumberExpression` and a constant value.
      Specified by:
        `divide` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### divide

          public FloatBinding divide​(int other)

      Description copied from interface: `NumberExpression`
      Creates a new `NumberBinding` that calculates the division of this `NumberExpression` and a constant value.
      Specified by:
        `divide` in interface `NumberExpression`
      Parameters:
        `other` - the constant value
      Returns:
        the new `NumberBinding`

    - #### asObject

          public ObjectExpression<Float> asObject()

      Creates an `ObjectExpression` that holds the value of this `FloatExpression`. If the value of this `FloatExpression` changes, the value of the `ObjectExpression` will be updated automatically.
      Returns:
        the new `ObjectExpression`
      Since:
        JavaFX 8.0